import java.awt.*;

public class ExtensionArmoredClass {
    private static final String _separatorForObject = ":";

    public static  DrawingArmoredCar CreateDrawingArmoredCar(String info) {
        String[] strs = info.split(_separatorForObject);
        if (strs.length == 3)
        {
            return new DrawingArmoredCar(Integer.parseInt(strs[0]), Integer.parseInt(strs[1]), Color.decode(strs[2]));
        }
        if (strs.length == 6)
        {
            return new DrawingTank(Integer.parseInt(strs[0]),
                    Integer.parseInt(strs[1]), Color.decode(strs[2]),
                    Color.decode(strs[3]), Boolean.parseBoolean((strs[4])),
                    Boolean.parseBoolean(strs[5]));
        }
        return null;
    }

//    public static IDrawingCaterpillar CreateIDrawingCaterpillar(String info) {
//        String[] strs = info.split(_separatorForObject);
//        switch (strs[0]) {
//            case "": {
//                break;
//            }
//            case "": {
//                break;
//            }
//            case "": {
//                break;
//            }
//        }
//    }

    public static String GetDataForSave(DrawingArmoredCar drawingArmoredCar)
    {
        var armoredCar = drawingArmoredCar.armoredCar;
        var str = String.format("%d%s%d%s%d", armoredCar.getSpeed(), _separatorForObject,
                (int)armoredCar.getWeight(), _separatorForObject, armoredCar.getBodyColor().getRGB());
        if (!(armoredCar instanceof EntityTank tank))
        {
            return str;
        }
        return String.format("%s%s%d%s%s%s%s", str, _separatorForObject,
                tank.getDopColor().getRGB(), _separatorForObject, tank.isTowerWeapon(), _separatorForObject, tank.isAMachineGun());
    }

    public static String GetDataForSave(IDrawingCaterpillar drawingCaterpillar) {
        return String.format("%s%s%d%s%d", drawingCaterpillar.getClass().getName(), _separatorForObject,
                drawingCaterpillar.getColor().getRGB(), _separatorForObject, drawingCaterpillar.getNumRinks().val());
    }


}
