import java.util.*;

public class SetArmoredCarsGeneric<T> {
    private ArrayList<T> _places;
    private int maxCount;

    public SetArmoredCarsGeneric(int count)
    {
        _places = new ArrayList<T>();
        maxCount = count;
    }

    public int getCount() {
        return _places != null ? _places.size() : 0;
    }

    public int Insert(T armoredCar)
    {
        return Insert(armoredCar, 0);
    }

    public int Insert(T armoredCar, int position)
    {
        if (getCount() >= maxCount || position < 0 || position >= maxCount)
            return -1;

        _places.add(position, armoredCar);
        return position;
    }

    public T Remove(int position)
    {
        if (position < 0 ||  position >= _places.size())
            return null;
        T armoredCar = _places.get(position);
        _places.remove(position);
        return armoredCar;
    }

    public T Get(int position)
    {
        if (position < 0 || position >= maxCount)
            return null;
        return _places.get(position);
    }

    public Iterable<T> GetArmoredCars()
    {
        return () -> _places.stream().filter(Objects::nonNull).iterator();
    }
}
